

/**

Move logic to the app.js
Simulate touchxxx from gesturexxx, not other way around (add preprocessor to remove the latter from the extension code)
Disable such events for presentation mode
Don't rely textlayerrenderer, there is no reason to not do it without this event
Invoke zoom methods of PDFViewerApplication instead of button click()

*/

var gesturesSetUp = false;
var isAndroid = navigator.userAgent.toLowerCase().indexOf("android") > -1;

var docElementTouchStart =  function (event) {
  if (event.touches.length > 1) {
    event.preventDefault();
  }
};


var steps = 1;
var zoomStyle = "-moz-transform: scale(0.8, 0.8);zoom: 0.8;zoom: 80%";

///*
//* -moz-transform: scale(0.8, 0.8); /!* Moz-browsers *!/
// zoom: 0.8; /!* Other non-webkit browsers *!/
// zoom: 80%; /!* Webkit browsers *!/
//  * @param text
// *!/

var setText = function(text) {
  document.getElementById('numPages').innerHTML = steps + " -- " + text;
}

var getZoomFactor = function(newZoom) {
  var zoom = newZoom;

  if ( newZoom > 1 ) {
    zoom = Math.abs(((1 - newZoom) / 2)) + 1;
    steps = Math.round(zoom);
  } else if ( newZoom  < 1 ) {
    zoom = ((1 - newZoom) / 2) + newZoom;
    steps = Math.round(((1-newZoom)*10));
  }

  return zoom;
}

/**
 *
 * @param eleName
 * @param newZoom
 */

var updateEle = function(eleName, zoom) {
  //var zoom = getZoomFactor(newZoom);
  var el = document.getElementById(eleName);
  el.style.cssText = zoomStyle.replace("0.8", zoom).replace("80%", (zoom*100)+"%");
}

var textLayerRendered = function (e) {
  if (gesturesSetUp || e.detail.pageNumber !== PDFViewerApplication.page) {
    return;
  }
  var viewer = document.getElementById('viewer');
  // http://blog.fspm.jp/2014/06/androidpinch-inoutjsgesturestart.html
  var funcGestureStart = function (e) {};
  var funcGestureChange = function (e) {};
  var funcGestureEnd = function (e) {
    if (e.scale < 1.0) {
      // User moved fingers closer together
      PDFViewerApplication.zoomOut(steps);
    } else if (e.scale > 1.0) {
      // User moved fingers further apart
      PDFViewerApplication.zoomIn(steps);
    }

    //updateEle('viewer', 1);
  };

  // iOS
  document.body.addEventListener('gesturestart', funcGestureStart, false);
  document.body.addEventListener('gesturechange', funcGestureChange, false);
  document.body.addEventListener('gestureend', funcGestureEnd, false);
  // Android
  if (isAndroid) {
    var pinchDistance = 0;
    var pinchScale = 1;
    var funcTouchStart = function(e){
      if(e.touches.length > 1){
        pinchDistance = Math.sqrt(Math.pow((e.touches[1].pageX - e.touches[0].pageX),2)+Math.pow((e.touches[1].pageY - e.touches[0].pageY),2));
        funcGestureStart(e);
      } else {
        pinchDistance = 0;
        pinchScale = 1;
      }
    };
    var funcTouchMove =  function (e) {
      if (pinchDistance <= 0 || e.touches.length < 2) {
        return;
      }
      var newDistance = Math.sqrt(Math.pow((e.touches[1].pageX - e.touches[0].pageX),2)+Math.pow((e.touches[1].pageY - e.touches[0].pageY),2));
      pinchScale = newDistance / pinchDistance;

      var newZoom = getZoomFactor(pinchScale);
      //setText(newZoom);
      //updateEle('viewer', newZoom);

      var event = { scale: pinchScale };
      funcGestureChange(event);
    };

    var funcTouchEnd = function (e) {
      if (pinchDistance <= 0 || e.touches.length > 0) {
        return;
      }
      var event = {scale: pinchScale};
      funcGestureEnd(event);
    };

    document.body.addEventListener('touchstart', funcTouchStart, false);
    document.body.addEventListener('touchmove', funcTouchMove);
    document.body.addEventListener('touchend', funcTouchEnd);
  }
  gesturesSetUp = true;
};

document.addEventListener('textlayerrendered', textLayerRendered, true);
document.documentElement.addEventListener('touchstart', docElementTouchStart, false);
